pipeline{
    environment{
        registry = "sharifdocker123/petclinic"
        registryCredential = "docker_hub_sharif"
        dockerImage = ''
    }
    agent any
    stages{
        stage('Build'){
            steps{
                echo "Buildiing project"
                sh './mvnw package'
            }
        }

        //Archive of the artifacts in Jenkins is a feature that allows us to store the output files after we build the project with Jenkins.
        stage ('Archive') {
            steps{
                echo "Archiving Project"
                archiveArtifacts artifacts: '**/*.jar', followSymlinks: false
            }
        }
    
        stage ('Build Docker Image') {
            steps{
                echo "Building Docker Image"
                script{
                    dockerImage = docker.build registry + ":$BUILD_NUMBER"       
                }
            }
        }
    
        stage ('Push Docker Image') {
            steps{
                echo "Pushing Docker Image"
                script{
                    docker.withRegistry( '', registryCredential ) {
                        dockerImage.push()
                        dockerImage.push('latest')      
                    }
                }
            }
        }
        stage ('Deploy to Dev') {
            steps{
                echo "Deploying to Dev Environment"
                sh "docker rm -f petclinic || true"
                sh "docker run -d --name=petclinic -p 8081:8080 sharifdocker123/petclinic"
            }
        }
    }
}